<?php
// 这是系统自动生成的公共文件

function create_tree_list($pid, $arr, &$tree = [])
{
    foreach ($arr as $key => $vo) {
        if ($vo['pid'] == $pid) {
            unset($vo['pid']);
            $vo['spread']=true;
            $c = create_tree_list($vo['id'], $arr);

            if ($c) {

                $vo['children'] = $c;
            }
            $tree[] = $vo;
        }
    }
    return $tree;
}

function index_list($pid, $arr, &$tree = [])
{
    foreach ($arr as $key => $vo) {
        if ($vo['pid'] == $pid) {
            $vo['spread']=true;
            $c = create_tree_list($vo['id'], $arr);

            if ($c) {

                $vo['children'] = $c;
            }
            $tree[] = $vo;
        }
    }
    return $tree;
}
//layui分页
function page_array($arr, $page = 10, $curr)
{

    $total = ceil(count($arr) / $page);
    if ($curr <= 0) $curr = 1;
    if ($curr > $total) $curr = $total;

    $data = array_slice($arr, ($curr - 1) * $page, $page);
    return [
        'data' => $data,
        'page' => [
            'count' => count($arr),
            'limit' => $page,
            'curr' => $curr
        ]
    ];

}
function alert_error($msg='',$url='',$time=2)
{

    $str = '<link rel="stylesheet" type="text/css" href="/static/admin/font/iconfont.css" /><link rel="stylesheet" type="text/css" href="/static/admin/lib/layui/css/layui.css" /><script type="text/javascript" src="/static/admin/js/jquery.min.js"></script> <script type="text/javascript" src="/static/admin/lib/layui/layui.js"></script>';//加载jquery和layer

    $str .= '<div class="layui-container"><div class="fly-panel" style="width: 100%;text-align: center;font-size: 50px;padding-top: 24px"> <div class="fly-none"> <h2><i class="iconfont icon-meh" style="width: 100%;text-align: center;font-size: 120px;color: #f00"></i></h2>  <p style="font-size: 24px;color: #666;margin-top: 50px">'.$msg.'</p> </div></div></div>';
    return $str;
}

function imgres($url){

    $path = $url;
    $mimetype = exif_imagetype($path);
    if ($mimetype == IMAGETYPE_GIF || $mimetype == IMAGETYPE_JPEG || $mimetype == IMAGETYPE_PNG || $mimetype == IMAGETYPE_BMP){
        return true;
    }else {
        return false;
    }
}
function status($data){
   // 启用状态 0待付款 1已付款2已发货3完成交易  4退款关闭 5退款中 6退款异常，7退货完成
    if ($data==0){
        return '待付款';
    }elseif ($data==1){
        return '待发货';
    }elseif ($data==2){
        return '已发货';
    }elseif ($data==3){
        return '完成交易';
    }elseif ($data==4){
        return '退款关闭';
    }elseif ($data==5){
        return '退款中';
    }elseif ($data==6){
        return '退款异常';
    }else{
        return '退货完成';
    }
}
function attr($data){

    if ($data==0){
        return '购买';
    }elseif ($data==1){
        return '团购';
    }elseif ($data==2){
        return '砍一刀';
    }elseif ($data==3){
        return '兑换';
    }elseif ($data==4){
        return '购物车购买';
    }elseif ($data==5){
        return '充值';
    }else{
        return '购买';
    }

}


//字符串截取

function cut_str($sourcestr,$cutlength)

{

    $returnstr='';

    $i=0;

    $n=0;

    $str_length=strlen($sourcestr);//字符串的字节数

    while (($n<$cutlength) and ($i<=$str_length))

    {

        $temp_str=substr($sourcestr,$i,1);

        $ascnum=Ord($temp_str);//得到字符串中第$i位字符的ascii码

        if ($ascnum>=224)    //如果ASCII位高与224，

        {

            $returnstr=$returnstr.substr($sourcestr,$i,3); //根据UTF-8编码规范，将3个连续的字符计为单个字符

            $i=$i+3;            //实际Byte计为3

            $n++;            //字串长度计1

        }

        elseif ($ascnum>=192) //如果ASCII位高与192，

        {

            $returnstr=$returnstr.substr($sourcestr,$i,2); //根据UTF-8编码规范，将2个连续的字符计为单个字符

            $i=$i+2;            //实际Byte计为2

            $n++;            //字串长度计1

        }

        elseif ($ascnum>=65 && $ascnum<=90) //如果是大写字母，

        {

            $returnstr=$returnstr.substr($sourcestr,$i,1);

            $i=$i+1;            //实际的Byte数仍计1个

            $n++;            //但考虑整体美观，大写字母计成一个高位字符

        }

        else                //其他情况下，包括小写字母和半角标点符号，

        {

            $returnstr=$returnstr.substr($sourcestr,$i,1);

            $i=$i+1;            //实际的Byte数计1个

            $n=$n+0.5;        //小写字母和半角标点等与半个高位字符宽...

        }

    }

    if ($str_length>$i){

        $returnstr = $returnstr . "...";//超过长度时在尾处加上省略号

    }

    return $returnstr;

}


/**
 * 隐藏部分字符串
 * # 此方法多用于手机号码或身份证号、银行卡号的中间部分数字的隐藏
 */
function func_substr_replace($str, $replacement = '*', $start = 4, $length = 8)
{
    $len = mb_strlen($str,'utf-8');
    if ($len > intval($start+$length)) {
        $str1 = mb_substr($str,0,$start,'utf-8');
        $str2 = mb_substr($str,intval($start+$length),NULL,'utf-8');
    } else {
        $str1 = mb_substr($str,0,1,'utf-8');
        $str2 = mb_substr($str,$len-1,1,'utf-8');
        $length = $len - 2;
    }
    $new_str = $str1;
    for ($i = 0; $i < $length; $i++) {
        $new_str .= $replacement;
    }
    $new_str .= $str2;
    return $new_str;
}


function GetImage($url, $filename = "") {

    if($url == "") {

        return false;

    }

    if ($filename == "") {

        $ext = strrchr($url, ".");

        if ($ext != ".png" && $ext != ".jpg" && $ext != ".jpeg" && $ext != ".gif") {

            return false;

        }

        $filename = app()->getRootPath().'runtime/'.time() . $ext;

    }

    //文件 保存路径

    ob_start ();

    readfile ( $url );

    $img = ob_get_contents ();

    ob_end_clean ();

    $size = strlen ( $img );

    //文件大小

    $fp2 = @fopen ( $filename, "a" );

    fwrite ( $fp2, $img );

    fclose ( $fp2 );

    return $filename;

}

//删除缓存文件目录
function delete_dir_file($dir_name) {
    $result = false;
    if(is_dir($dir_name)){
        if ($handle = opendir($dir_name)) {
            while (false !== ($item = readdir($handle))) {
                if ($item != '.' && $item != '..') {
                    if (is_dir($dir_name . '/' . $item)) {
                        delete_dir_file($dir_name .  '/' . $item);
                    } else {
                        unlink($dir_name .  '/'. $item);
                    }
                }
            }
            closedir($handle);
            if (rmdir($dir_name)) {
                $result = true;
            }
        }
    }
    return $result;
}



function Getwx($url, $filename = "") {

    if($url == "") {

        return false;

    }

    if ($filename == "") {

        $ext = strrchr($url, ".");

        if ($ext != ".png" && $ext != ".jpg" && $ext != ".jpeg" && $ext != ".gif") {

            return false;

        }

        $filename = app()->getRootPath().'runtime/'.time() . $ext;

    }

    //文件 保存路径

    ob_start ();

    readfile ( $url );

    $img = ob_get_contents ();

    ob_end_clean ();

    $size = strlen ( $img );

    //文件大小

    $fp2 = @fopen ( $filename, "a" );

    fwrite ( $fp2, $img );

    fclose ( $fp2 );

    return $filename;

}
//
////图片预览通用
function getpics($file,$height=30){
    //文件路径解码并进行编码转换
    $file=iconv('utf-8','gb2312',urldecode($file));
    if($file_info=@getimagesize($file)){//判断文件是否是有效的图像文件
        $filecontent=file_get_contents($file);//获取图像文件内容
        $base64_file=chunk_split(base64_encode($filecontent));//对图像文件编码并转换
        $pic="data:".$file_info['mime'].";base64,".$base64_file;//组织方便页面显示的图像数据
        return $pic;//返回可直接显示的图像数据
    }
    return "";
}


function basenamecn($file){
    $file=iconv('UTF-8','GB2312',$file);
    if (file_exists($file)){
        $arr=explode('/',$file);
        return iconv('GB2312','UTF-8',end($arr));
    }
}


function format_size($size){
    $arr=['B','KB','M','G','T'];
    $i=0;
    while ($size>=1024){
        $size=$size/1024;
        $i++;
    }
    return round($size,2).$arr[$i];
}
